mod\_dav\_lock

Generic locking module for

mod\_dav

Extension

mod\_dav\_lock.c

dav\_lock\_module

This module implements a generic locking API which can be used by any
backend provider of

mod\_dav

. It

requires

at least the service of

mod\_dav

. But without a backend provider which makes use of it, it\'s useless
and should not be loaded into the server. A sample backend module which
actually utilizes

mod\_dav\_lock

is

mod\_dav\_svn

, the subversion provider module.

Note that

mod\_dav\_fs

does

not

need this generic locking module, because it uses its own more
specialized version.

In order to make

mod\_dav\_lock

functional, you just have to specify the location of the lock database
using the

DavGenericLockDB

directive described below.

> **Note**
>
> In order to retrieve the pointer to the locking provider function, you
> have to use the
>
> ap\_lookup\_provider
>
> API with the arguments
>
> dav-lock
>
> ,
>
> generic
>
> , and
>
> 0
>
> .

mod\_dav

DavGenericLockDB

Location of the DAV lock database

DavGenericLockDB

file-path

server config

virtual host

directory

Use the

DavGenericLockDB

directive to specify the full path to the lock database, excluding an
extension. If the path is not absolute, it will be interpreted relative
to

ServerRoot

. The implementation of

mod\_dav\_lock

uses a SDBM database to track user locks.

DavGenericLockDB var/DavLock

The directory containing the lock database file must be writable by the

User

and

Group

under which Apache is running. For security reasons, you should create a
directory for this purpose rather than changing the permissions on an
existing directory. In the above example, Apache will create files in
the

var/

directory under the

ServerRoot

with the base filename

DavLock

and an extension added by the server.
