mod\_ident

RFC 1413 ident lookups

Extension

mod\_ident.c

ident\_module

This module queries an

RFC 1413

compatible daemon on a remote host to look up the owner of a connection.

mod\_log\_config

IdentityCheck

Enables logging of the RFC 1413 identity of the remote user

IdentityCheck On\|Off

IdentityCheck Off

server config

virtual host

directory

This directive enables

RFC 1413

-compliant logging of the remote user name for each connection, where
the client machine runs identd or something similar. This information is
logged in the access log using the

\%\...l

format string

.

> **Note**
>
> The information should not be trusted in any way except for
> rudimentary usage tracking.

Note that this can cause serious latency problems accessing your server
since every request requires one of these lookups to be performed. When
firewalls or proxy servers are involved, each lookup might possibly fail
and add a latency duration as defined by the

IdentityCheckTimeout

directive to each hit. So in general this is not very useful on public
servers accessible from the Internet.

IdentityCheckTimeout

Determines the timeout duration for ident requests

IdentityCheckTimeout

seconds

IdentityCheckTimeout 30

server config

virtual host

directory

This directive specifies the timeout duration of an ident request. The
default value of 30 seconds is recommended by

RFC 1413

, mainly because of possible network latency. However, you may want to
adjust the timeout value according to your local network speed.
