mod\_proxy\_wstunnel

Websockets support module for

mod\_proxy

Extension

mod\_proxy\_wstunnel.c

proxy\_wstunnel\_module

Available in httpd 2.4.5 and later

This module

requires

the service of

mod\_proxy

. It provides support for the tunnelling of web socket connections to a
backend websockets server. The connection is automatically upgraded to a
websocket connection:

Upgrade: WebSocket Connection: Upgrade

Proxying requests to a websockets server like

echo.websocket.org

can be done using the

ProxyPass

directive:

ProxyPass \"/ws2/\" \"ws://echo.websocket.org/\" ProxyPass \"/wss2/\"
\"wss://echo.websocket.org/\"

Proxying both HTTP and websockets at the same time can be done by
specifying the websockets

ProxyPass

directive before the HTTP directive:

ProxyPass \"/\" \"ws://backend.example.com:9080/\" ProxyPass \"/\"
\"http://backend.example.com:9080/\"

Load balancing for multiple backends can be achieved using

mod\_proxy\_balancer

.

In fact the module can be used to upgrade to other protocols, you can
set the

upgrade

parameter in the

ProxyPass

directive to allow the module to accept other protocol. NONE means you
bypass the check for the header but still upgrade to WebSocket. ANY
means that

Upgrade

will read in the request headers and use in the response

Upgrade

mod\_proxy

ProxyWebsocketFallbackToProxyHttp

Instructs this module to let

mod\_proxy\_http

handle the request

ProxyWebsocketFallbackToProxyHttp On\|Off

ProxyWebsocketFallbackToProxyHttp On

server config

virtual host

Available in httpd 2.4.48 and later

Since httpd 2.4.47,

mod\_proxy\_http

can handle WebSocket upgrading and tunneling in accordance to RFC 7230,
this directive controls whether

mod\_proxy\_wstunnel

should hand over to

mod\_proxy\_http

to this, which is the case by default.

Setting to

Off

lets

mod\_proxy\_wstunnel

handle WebSocket requests as in httpd 2.4.46 and earlier.

ProxyWebsocketAsync

Instructs this module to try to create an asynchronous tunnel

ProxyWebsocketAsync ON\|OFF

server config

virtual host

This directive instructs the server to try to create an asynchronous
tunnel. If the current MPM does not support the necessary features, a
synchronous tunnel is used.

> **Note**
>
> Async support is experimental and subject to change.

ProxyWebsocketIdleTimeout

Sets the maximum amount of time to wait for data on the websockets
tunnel

ProxyWebsocketIdleTimeout

num

\[ms\]

ProxyWebsocketIdleTimeout 0

server config

virtual host

This directive imposes a maximum amount of time for the tunnel to be
left open while idle. The timeout is considered in seconds by default,
but it is possible to increase the time resolution to milliseconds
adding the

ms

suffix.

ProxyWebsocketAsyncDelay

Sets the amount of time the tunnel waits synchronously for data

ProxyWebsocketAsyncDelay

num

\[ms\]

ProxyWebsocketAsyncDelay 0

server config

virtual host

If

ProxyWebsocketAsync

is enabled, this directive controls how long the server synchronously
waits for more data. The timeout is considered in seconds by default,
but it is possible to increase the time resolution to milliseconds
adding the

ms

suffix.

> **Note**
>
> Async support is experimental and subject to change.
