mod\_sed

Filter Input (request) and Output (response) content using

sed

syntax

Experimental

mod\_sed.c sed0.c sed1.c regexp.c regexp.h sed.h

sed\_module

Available in Apache 2.3 and later

mod\_sed

is an in-process content filter. The

mod\_sed

filter implements the

sed

editing commands implemented by the Solaris 10

sed

program as described in the

manual page

. However, unlike

sed

,

mod\_sed

doesn\'t take data from standard input. Instead, the filter acts on the
entity data sent between client and server.

mod\_sed

can be used as an input or output filter.

mod\_sed

is a content filter, which means that it cannot be used to modify client
or server http headers.

The

mod\_sed

output filter accepts a chunk of data, executes the

sed

scripts on the data, and generates the output which is passed to the
next filter in the chain.

The

mod\_sed

input filter reads the data from the next filter in the chain, executes
the

sed

scripts, and returns the generated data to the caller filter in the
filter chain.

Both the input and output filters only process the data if newline
characters are seen in the content. At the end of the data, the rest of
the data is treated as the last line.

Sample Configuration {#sampleconf}
====================

\# In the following example, the sed filter will change the string \#
\"monday\" to \"MON\" and the string \"sunday\" to SUN in html documents
\# before sending to the client. \<Directory \"/var/www/docs/sed\"\>
AddOutputFilter Sed html OutputSed \"s/monday/MON/g\" OutputSed
\"s/sunday/SUN/g\" \</Directory\>

\# In the following example, the sed filter will change the string \#
\"monday\" to \"MON\" and the string \"sunday\" to SUN in the POST data
\# sent to PHP. \<Directory \"/var/www/docs/sed\"\> AddInputFilter Sed
php InputSed \"s/monday/MON/g\" InputSed \"s/sunday/SUN/g\"
\</Directory\>

Sed Commands {#sed_commands}
============

Complete details of the

sed

command can be found from the

sed manual page

.

b

Branch to the label specified (similar to goto).

h

Copy the current line to the hold buffer.

H

Append the current line to the hold buffer.

g

Copy the hold buffer to the current line.

G

Append the hold buffer to the current line.

x

Swap the contents of the hold buffer and the current line.

OutputSed

Sed command for filtering response content

OutputSed

sed-command

directory

.htaccess

The

OutputSed

directive specifies the

sed

command to execute on the response.

InputSed

Sed command to filter request data (typically

POST

data)

InputSed

sed-command

directory

.htaccess

The

InputSed

directive specifies the

sed

command to execute on the request data e.g.,

POST

data.
